<template>
  <div class="tagEditor">
    <b-taglist>
      <b-tag
        v-for="tag in modelTags"
        v-bind:key="tag"
        type="is-info"
        @close="removeTagFromModel(tag)"
        closable>

        {{tag}}
      </b-tag>
    </b-taglist>

    <b-collapse
      class="card"
      animation="slide"
      v-for="(category, index) of aviablesTags"
      :key="index"
      :open="isOpen == index"
      @open="isOpen = index">

      <div
        slot="trigger"
        slot-scope="props"
        class="card-header"
        role="button">

        <p class="card-header-title">
          {{category.name}}
        </p>
        <a class="card-header-icon">
          <b-icon :icon="props.open ? 'menu-down' : 'menu-up'"/>
        </a>
      </div>

      <div class="card-content">
        <div class="buttons">
          <b-button
            v-for="tag in category.tags"
            v-bind:key="tag.name"
            @click="addTagToModel(tag.name)"
            type="is-info"
            rounded>

            {{tag.name}}
          </b-button>

          <b-button
            @click="addNewTagDialog(category.id)"
            type="is-warning"
            icon-right="plus"
            rounded/>
        </div>
      </div>
    </b-collapse>
  </div>
</template>

<script>
import { api } from '@/api.js'

export default {
  name: 'TagEditor',
  props: {
    modelTags: {
      type: Array,
      default: function () {
        return []
      }
    }
  },
  data () {
    return {
      aviablesTags: [],
      isOpen: 0
    }
  },
  async mounted () {
    this.aviablesTags = await api.getTags()
  },
  methods: {
    addNewTagDialog (categoryId) {
      this.$buefy.dialog.prompt({
        message: 'Tag',
        inputAttrs: {
          maxlength: 20
        },
        confirmText: 'Add',
        onConfirm: async (value) => {
          await api.addNewTag(value, categoryId)
          this.aviablesTags = await api.getTags()
        }
      })
    },
    addTagToModel (tag) {
      this.modelTags.push(tag)
      this.syncToParent()
    },
    removeTagFromModel (tag) {
      const index = this.modelTags.indexOf(tag)
      if (index > -1) {
        this.modelTags.splice(index, 1)
      }
      this.syncToParent()
    },
    syncToParent () {
      this.$emit('update-tags', this.modelTags)
    }
  }
}
</script>

<style>

</style>
